## yorick-1.6.02.tgz

=== Makefile ===
# Makefile - $Id$
# see README for usage

SHELL=/bin/sh

ALLDIRS=play gist yorick regexp matrix fft doc
CONFIGDIRS=play yorick

all: yorexe gistexe docs

yorexe: libyor
	@cd yorick; $(MAKE)

gistexe: libgist
	@cd gist; $(MAKE) gist

docs:
	@cd doc; $(MAKE) docs

# libraries are built in a fixed order:
# libplay, then libgist, then libyor
#   - the libraries are accumulated, that is,
#     libyor.a contains libgist.a contains libplay.a

libyor: libgist
	@cd regexp; $(MAKE) libyor
	@cd matrix; $(MAKE) libyor
	@cd fft; $(MAKE) libyor
	@cd yorick; $(MAKE) libyor.a

libgist: libplay
	@cd gist; $(MAKE) libgist.a

libplay: Make.cfg
	@cd play; $(MAKE) libplay

LD_STATIC=
Make.cfg:
	LD_STATIC=$(LD_STATIC) ./configure

config: distclean
	@$(MAKE) "LD_STATIC=$(LD_STATIC)" Make.cfg

prefix=.
Y_PLATFORM=.
Y_SITE=.
Y_HOME=.
ysite:
	if S="s?^prefix=.*?prefix=\"$(prefix)\"?;\
	s?^Y_PLATFORM=.*?Y_PLATFORM=\"$(Y_PLATFORM)\"?;\
	s?^Y_SITE=.*?Y_SITE=\"$(Y_SITE)\"?;\
	s?^Y_HOME=.*?Y_HOME=\"$(Y_HOME)\"?";\
	sed -e "$$S" ysite.sh >ysite.sh1; then mv ysite.sh1 ysite.sh; fi
	@if test -r ysite.grp; then chmod g+w ysite.sh; fi

clean::
	@rm -f Make.del yorapi.def
	@if test ! -r Make.cfg; then touch Make.cfg Make.del; fi
	@for d in $(ALLDIRS); do ( cd $$d; $(MAKE) TGT=exe clean; ); done
	@if test -r Make.del; then rm -f Make.cfg Make.del; fi
	rm -f *~ '#'* *.o cfg* ysite.sh? core a.out
	rm -f i/*~ i0/*~ i-start/*~ g/*~ extend/*~
	rm -rf relocate

distclean::
	@touch Make.cfg
	@for d in $(ALLDIRS); do ( cd $$d; $(MAKE) TGT=exe distclean; ); done
	rm -f *~ '#'* *.o cfg* Make.* ysite.sh? core a.out
	rm -f i/*~ i0/*~ i-start/*~ g/*~ extend/*~

siteclean: distclean
	@rm -f ysite.grp
	@$(MAKE) prefix=. Y_PLATFORM=. Y_SITE=. Y_HOME=. ysite


check:
	@cd yorick; $(MAKE) check

INSTALL_ROOT=
Y_BINDIR=
Y_DOCDIR=
install: yorexe gistexe docs
	./instally.sh +both "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

install1: yorexe gistexe
	./instally.sh +home "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

uninstall:
	./instally.sh -both "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

uninstall1:
	./instally.sh -home "$(INSTALL_ROOT)" "$(Y_BINDIR)" "$(Y_DOCDIR)"

dist: siteclean
	W=`pwd`;N=`basename "$$W"`;R=`tail -n 1 VERSION`;cd ..;\
	tar cvf - $$N|gzip - >$$N.$$R.tgz;

# Usage: make YGROUP=altgrp sharable
# default group is "yorick", affects instally.sh
YGROUP=yorick
sharable:
	@rm -f ysite.grp
	echo "$(YGROUP)" >ysite.grp
	chgrp -R $(YGROUP) .
	chmod -R g+w .
	find . -type d | xargs chmod g+s

relocatable: siteclean
	@rm -rf relocate
	$(MAKE) Y_HOME=relocate ysite
	$(MAKE) install
	cp install.rel relocate/README
	cp emacs/yorick.el relocate
	mkdir relocate/contrib
	W=`pwd`;N=`basename "$$W"`;R=`tail -n 1 VERSION`;\
	mv relocate $$N-$$R;tar cvf - $$N-$$R|gzip - >$$N-$$R.tgz;\
	rm -rf $$N-$$R

# targets for ./configure
echocc:
	echo "$(CC)" >cfg.tmp
echorl:
	echo "$(RANLIB)" >cfg.tmp
echoar:
	echo "$(AR)" >cfg.tmp
echoml:
	echo "$(MATHLIB)" >cfg.tmp
pkgconfig:
	@for d in $(CONFIGDIRS); do ( cd $$d; $(MAKE) config; ); done

=== doc/Makefile ===
# you need the makeinfo and texi2dvi programs from gnu.org
# and the tex typesetting system from tug.org
MAKEINFO = makeinfo
TEXI2DVI = texi2dvi
TEXI2PDF = texi2pdf
TEX = tex
PDFTEX = pdftex
YORICK = ../yorick/yorick

all: yorick.info docs

docs:
	$(YORICK) -batch maked.i

yorick.info: yorick.tex
	$(MAKEINFO) yorick.tex

yorick.dvi: yorick.tex
	$(TEXI2DVI) yorick.tex

yorick.pdf: yorick.tex
	$(TEXI2PDF) yorick.tex

refs.dvi: refs.tex
	$(TEX) refs.tex

refs.pdf: refs.tex
	$(PDFTEX) refs.tex

TEX_AUX=*.aux *.log *.toc *.cp *.fn *.ky *.pg *.tp *.vr *.tmp
clean::
	rm -f *~ '#'* *.inf* *.dvi *.doc $(TEX_AUX)

distclean:: clean

=== drat/Makefile ===
# drat/Makefile
# $Id$
# similar to any yorick package Makefile

COPT=$(COPT_DEFAULT)
TGT=$(DEFAULT_TGT)

# ------------------------------------------------ macros for this package
Y_MAKEDIR=..
Y_EXE=../yorick/yorick$(EXE_SFX)
PKG_NAME=drat
PKG_EXENAME=yorick
PKG_I=drat.i

OBJS=bound.o track.o trans.o drat.o ydrat.o

PKG_CLEAN=../i0/drat.i

# in ordinary yorick packages, these dependencies unnecessary
# they appear here because this package is part of baseline yorick
H_DEPS=../play/plugin.h
H_YDATA=../yorick/ydata.h ../yorick/binio.h ../yorick/hash.h
H_YWRAP=../play/play.h $(H_YDATA) $(H_DEPS)
H_YDRAT=../yorick/yio.h $(H_YDATA) ../play/pstdlib.h ../play/pstdio.h $(H_DEPS)

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
PKG_I_DEPS=$(PKG_I)

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_IDIR=-I. -I../play -I../yorick
Y_LIBEXE=../yorick
Y_EXE=../yorick/yorick

# ------------------------------------- targets and rules for this package

bound.o: bound.h
track.o: track.h   bound.h
trans.o: trans.h   track.h bound.h
drat.o: drat.h   trans.h track.h bound.h
ydrat.o: drat.h   trans.h track.h bound.h  $(H_YDRAT)

../i0/drat.i: drat.i
	cp -f drat.i ../i0/drat.i

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
preexe: $(PKG_LIB) ../i0/drat.i
predll:
	@:

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
postdll: $(PKG_DLL) ../i0/drat.i
postexe:
	@:

#-------------------------------------- end of Makefile

=== fft/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I../play
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

OBJS=cfft2.o cfftb.o cfftf.o cffti.o roll2.o

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean


cffti.o: cfft.h ../play/plugin.h
cfftf.o: cfft.h ../play/plugin.h
cfftb.o: cfft.h ../play/plugin.h
cfft2.o: cfft.h ../play/plugin.h
roll2.o: cfft.h ../play/plugin.h

=== gist/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I. -I../play
CCLOAD=$(CC) $(LDOPTIONS) $(LDFLAGS)
SYS_LIBS=$(X11LIB) $(MATHLIB) $(FPELIB)
COPTIONS=$(COPT) $(Y_CFLAGS)
LDOPTIONS=$(COPT) $(Y_LDFLAGS)
COPT=$(COPT_DEFAULT)

D_GISTPATH='-DGISTPATH="~/gist:~/Gist:$(Y_SITE)/g"'

OBJS=gist.o tick.o tick60.o engine.o gtext.o draw.o draw0.o clip.o \
  gread.o gcntr.o hlevel.o ps.o cgm.o xfancy.o xbasic.o
BOBJS=browser.o cgmin.o eps.o

all: gist

# always check to see whether ../play/libplay.a needs to be rebuilt
libgist:
	@cd ../play; $(MAKE) "COPT=$(COPT)"
	@$(MAKE) "COPT=$(COPT)" libgist.a

../play/libplay.a:
	@cd ../play; $(MAKE) "COPT=$(COPT)" libplay

libgist.a: ../play/libplay.a $(OBJS)
	cp ../play/libplay.a $@
	$(AR) r $@ $(OBJS)
	$(RANLIB) $@

gist: libgist.a $(BOBJS) main.o
	$(CCLOAD) -o $@ main.o $(BOBJS) -L. -lgist $(SYS_LIBS)

# libpyg target is for pygist
libpyg: libgist
	@$(MAKE) "COPT=$(COPT)" ../libpyg.a

../libpyg.a: libgist.a
	cp libgist.a ../libpyg.a
	$(RANLIB) ../libpyg.a

bench: libgist bench.o main.o
	$(CCLOAD) -o $@ main.o bench.o -L. -lgist $(SYS_LIBS)

main.c: ../play/$(Y_MAIN_C)
	cp ../play/$(Y_MAIN_C) main.c

clean::
	rm -f *~ '#'* *.o *.a core a.out main.c gist bench

distclean:: clean
	rm -f .gdb*

config:
	@:

# ------------- dependencies -------------

# cgm.h: gist.h engine.h
# draw.h: gist.h
# engine.h: gist.h
# gtext.h: gist.h
# hlevel.h: gist.h
# ps.h: gist.h engine.h
# xbasic.h: gist.h engine.h play.h
# xfancy.h: xbasic.h

PLUGEXT=../play/plugin.h
PLAY_H=../play/play.h $(PLUGEXT)
PSLIB=../play/pstdlib.h $(PLUGEXT)
PSLIO=../play/pstdlib.h ../play/pstdio.h $(PLUGEXT)
PLAYIO=../play/play.h ../play/pstdio.h $(PLUGEXT)
PSPLAY=../play/pstdlib.h ../play/play.h $(PLUGEXT)
PLAYALL=../play/play.h ../play/pstdlib.h ../play/pstdio.h $(PLUGEXT)

cgm.o: cgm.h gtext.h $(PLAYALL)  gist.h engine.h
clip.o: clip.h $(PSLIB)
draw.o: draw.c draw.h gtext.h $(PSLIB)  gist.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(NO_EXP10) -c draw.c
draw0.o: draw.h gtext.h $(PSPLAY)  gist.h
engine.o: engine.h gist.h draw.h $(PSLIB)
gcntr.o: gist.h
gist.o: gist.h engine.h clip.h $(PSPLAY)
gread.o: gread.c gist.h $(PLAYALL)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(D_GISTPATH) -c gread.c
gtext.o: gtext.h  gist.h
hlevel.o: hlevel.h xbasic.h engine.h $(PLAYIO)  gist.h
ps.o: ps.h gtext.h $(PLAYIO)  gist.h engine.h
tick.o: tick.c gist.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(NO_EXP10) -c tick.c
tick60.o: gist.h
xbasic.o: xbasic.h gtext.h $(PLAYIO)  gist.h engine.h
xfancy.o: xfancy.c xfancy.h draw.h  gist.h xbasic.h engine.h $(PLAY_H)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(NO_EXP10) -c xfancy.c

browser.o: xbasic.h cgm.h cgmin.h eps.h   gist.h engine.h $(PLAYALL)
cgmin.o: cgmin.h engine.h $(PLAYALL)   gist.h
eps.o: eps.h ps.h gtext.h $(PSLIO)   gist.h engine.h

bench.o: hlevel.h xfancy.h $(PLAYALL)  gist.h xbasic.h engine.h

# Always compile main.c with -g so new packages can be debugged.
main.o: main.c
	$(CC) $(CPPFLAGS) -I../play -g -c main.c

=== hex/Makefile ===
# hex/Makefile
# $Id$
# similar to any yorick package Makefile

COPT=$(COPT_DEFAULT)
TGT=$(DEFAULT_TGT)

# ------------------------------------------------ macros for this package
Y_MAKEDIR=..
Y_EXE=../yorick/yorick$(EXE_SFX)
PKG_NAME=hex
PKG_EXENAME=yorick
PKG_I=hex.i

OBJS=yhex.o hex5.o hex24.o hex.o regul.o tools.o store.o hydram.o

PKG_CLEAN=../i0/hex.i ../i/ylmdec.i

# in ordinary yorick packages, these dependencies unnecessary
# they appear here because this package is part of baseline yorick
H_DEPS=../play/plugin.h
H_YDATA=../yorick/ydata.h ../yorick/binio.h ../yorick/hash.h
H_YWRAP=../play/play.h $(H_YDATA) $(H_DEPS)
H_YHEX=../yorick/yio.h $(H_YDATA) ../play/pstdlib.h ../play/pstdio.h $(H_DEPS)

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
PKG_I_DEPS=$(PKG_I)

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_IDIR=-I. -I../play -I../yorick
Y_LIBEXE=../yorick
Y_EXE=../yorick/yorick

# ------------------------------------- targets and rules for this package

yhex.o: hex.h  tools.h
hex5.o: hex.h  tools.h
hex.o: hex.h  tools.h
tools.o: tools.h
store.o: tools.h
hydram.o: hydram.h hex.h  tools.h

../i0/hex.i: hex.i
	cp -f hex.i ../i0/hex.i
../i/ylmdec.i: ylmdec.i
	cp ylmdec.i ../i/ylmdec.i

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
preexe: $(PKG_LIB) ../i0/hex.i ../i/ylmdec.i
predll:
	@:

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
postdll: $(PKG_DLL) ../i0/hex.i ../i/ylmdec.i
postexe:
	@:

hex.doc:
	echo 'mkdoc,["hex.i","hydra.i"],"hex.doc";quit' | $(Y_EXE) -imkdoc.i

#-------------------------------------- end of Makefile

=== matrix/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I. -I../play
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

CBLASY=cblasy.o

# to use external blas (e.g.- atlas), comment above, uncomment below
# also need to add -lblas (or whatever) to MATHLIB in ../Make.cfg
#CFLAGS=$(COPTIONS) -DUSE_CBLAS -DCBLAS_INDEX=int -I.
#CBLASY=

OBJS=dlamc3.o dgyor.o dgtsv.o dgesv.o dgecon.o dgels.o dgelss.o \
  dbdsqr.o dlasr.o dgesvd.o dgesv2.o $(CBLASY)

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean

# ------------- dependencies -------------

dlamc3.o: dlamc3.c
	$(CC) $(CPPFLAGS) -g -I. -I../play -c dlamc3.c

dbdsqr.o: dg.h cblasy.h ../play/plugin.h
dgecon.o: dg.h cblasy.h ../play/plugin.h
dgels.o: dg.h cblasy.h ../play/plugin.h
dgelss.o: dg.h cblasy.h ../play/plugin.h
dgesv.o: dg.h cblasy.h ../play/plugin.h
dgesv2.o: dg.h cblasy.h ../play/plugin.h
dgesvd.o: dg.h cblasy.h ../play/plugin.h
dgtsv.o: dg.h cblasy.h ../play/plugin.h
dgyor.o: dg.h cblasy.h ../play/plugin.h
dlasr.o: dg.h cblasy.h ../play/plugin.h

=== mpy/Makefile ===
# Makefile for MPY = Message Passing Yorick based on the MPI standard
# $Id$

Y_MAKEDIR=..
Y_EXE=../yorick/yorick
Y_EXE_PKGS=
Y_EXE_HOME=
Y_EXE_SITE=

#Y_MAKEMPY=$(Y_MAKEDIR)/Makempy
Y_MAKEMPY=./Makempy

# ----------------------------------------------------- optimization flags

COPT=$(COPT_DEFAULT)
#TGT=$(DEFAULT_TGT)
TGT=exe

# ------------------------------------------------ macros for this package

PKG_NAME=mpy
PKG_I=mpy.i

OBJS=mpy.o

PKG_EXENAME=mpy

# PKG_DEPLIBS=-Lsomedir -lsomelib   for dependencies of this package
PKG_DEPLIBS=
# set compiler flags specific to this package
PKG_CFLAGS=$(MPI_CFLAGS)
PKG_LDFLAGS=

EXTRA_PKGS=$(Y_EXE_PKGS)

PKG_CLEAN=

PKG_I_START=
PKG_I_EXTRA=testmp.i

# -------------------------------- standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
# DLL_TARGETS, LIB_TARGETS, EXE_TARGETS
# are any additional targets (defined below) prerequisite to
# the plugin library, archive library, and executable, respectively
PKG_I_DEPS=$(PKG_I)

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros Makepkg sets for rules and other macros

# this overrides CC and FC macros, provides MPI_CFLAGS
include $(Y_MAKEMPY)

# Y_HOME and Y_SITE in Make.cfg may not be correct (e.g.- relocatable)
#Y_HOME=$(Y_EXE_HOME)
#Y_SITE=$(Y_EXE_SITE)

# ------------------------------------- targets and rules for this package

install:: Makempy
	$(YNSTALL) Makempy "$(Y_HOME)"

uninstall::
	rm -f "$(Y_HOME)/Makempy"

distclean::
	rm -f Makempy

# -------------------------------------------------------- end of Makefile

=== play/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

SUBDIRS=hacks $(PLAY_DIRS) any
ALLDIRS=hacks win unix x11 any

all: libplay

# the library is actually built from subdirectories (in order)
libplay:
	@for d in $(SUBDIRS); do ( cd $$d; $(MAKE); ); done

config:
	@for d in $(PLAY_DIRS); do ( cd $$d; $(MAKE) TGT=$(TGT) config; ); done

numfmt: libplay
	cd any; $(MAKE) numfmt

test2d: libplay
	cd any; $(MAKE) test2d

clean:: cleantop
	@for dir in $(ALLDIRS); do ( cd $$dir; $(MAKE) clean; ); done

distclean:: distcleantop
	@for dir in $(ALLDIRS); do ( cd $$dir; $(MAKE) distclean; ); done

cleantop:
	rm -f *~ '#'* *.o *.a core a.out hack*.h playwin.h

distcleantop: cleantop

=== regexp/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../Make.cfg

CFLAGS=$(COPTIONS) -I../play -I../yorick
COPTIONS=$(COPT) $(Y_CFLAGS)
COPT=$(COPT_DEFAULT)

OBJS=yfnmatch.o yregexp.o

all: $(OBJS)

libyor: $(OBJS)
	touch $@

oinsert: $(OBJS) ../yorick/libyor.a
	$(AR) r ../yorick/libyor.a $(OBJS)

config:
	@:

clean::
	rm -f *~ '#'* *.o *.a core a.out libyor

distclean:: clean


yfnmatch.o: yfnmatch.h ../play/plugin.h
yregexp.o: yregexp.h ../play/pstdlib.h ../play/plugin.h

=== yorick/Makefile ===
# yorick/Makefile
# $Id$
# similar to any yorick package Makefile

# ------------------------------------------------ macros for yor base package
COPT=$(COPT_DEFAULT)
Y_MAKEDIR=..
Y_EXE=./yorick
PKG_NAME=yor
PKG_EXENAME=yorick
PKG_I=std.i matrix.i fft.i graph.i
PKG_I_DEPS=../i0/std.i ../i0/matrix.i ../i0/fft.i ../i0/graph.i
PKG_I_DIR=-I../i0

OBJS = opsv.o task.o yorick.o yinput.o parse.o ydata.o yio.o fnctn.o \
  array.o range.o ops.o ops0.o ops1.o ops2.o ops3.o nonc.o debug.o \
  std0.o std1.o std2.o ascio.o defmem.o yhash.o  yrdwr.o bcast.o \
  binio.o binobj.o binstd.o cache.o convrt.o binpdb.o clog.o ystr.o \
  graph.o graph0.o style.o list.o pathfun.o autold.o fortrn.o

PKG_CLEAN=libyor main.c prmtyp.h codger lib$(PKG_NAME).a $(PKG_EXENAME) yorapi*

PLAPI=../play/plugin.h
PLAYONLY=../play/play.h $(PLAPI)

DIST_PKGS=drat hex
DIST_LIBS=-L../drat -ldrat -L../hex -lhex
DIST_DIRS=../drat ../hex

# ------------------------------------ standard targets and rules (in Makepkg)

# set macros Makepkg uses in target and dependency names
H_YWRAP=$(PLAYONLY) ydata.h binio.h hash.h
CODGER_DEP=codger
EXE_TARGETS=main.o $(YWIN_LIB) prepkg
LIB_TARGETS=libyor
ALL_TARGETS=postpkg
TGT=exe

include $(Y_MAKEDIR)/Make.cfg
include $(Y_MAKEDIR)/Makepkg
include $(Y_MAKEDIR)/Make$(TGT)

# override macros set by Makepkg used in rules (because yorick not installed)
Y_MAIN_O=main.o
Y_IDIR=-I. -I../play -I../gist
Y_LIBEXE=.
Y_LDIR=-L../drat -L../hex
PKG_L_OPT=-L.
ARFLAGS=r
EXTRA_LIBS=$(ALT_LIBS)

# hack combines gist, matrix, and fft libs into a single libyor.a
# (this does not get inter-directory dependencies absolutely correct)
BUILTIN_PKGS=../gist/libgist.a ../regexp/libyor ../matrix/libyor ../fft/libyor
libyor: $(BUILTIN_PKGS)
	@rm -f $(PKG_LIB)
	cp ../gist/libgist.a $(PKG_LIB)
	cd ../regexp; $(MAKE) "COPT=$(COPT)" oinsert
	cd ../matrix; $(MAKE) "COPT=$(COPT)" oinsert
	cd ../fft; $(MAKE) "COPT=$(COPT)" oinsert
	touch $@
../gist/libgist.a:
	@cd ../gist; $(MAKE) "COPT=$(COPT)" libgist.a
../regexp/libyor:
	@cd ../regexp; $(MAKE) "COPT=$(COPT)" libyor
../matrix/libyor:
	@cd ../matrix; $(MAKE) "COPT=$(COPT)" libyor
../fft/libyor:
	@cd ../fft; $(MAKE) "COPT=$(COPT)" libyor

# MSWindows and AIX need yorapi.def for plugins to work (see ../yorapi.sh)
yorapi.def:
	cd ..; ./yorapi.sh; mv yorapi.def yorick/

# if drat and hex are to be statically linked,
# their static libraries must be built before yorick
M_V1="TGT=exe" pre$(DISTRIB_TGT)
prepkg:
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) "COPT=$(COPT)" $(M_V1); ); done

# if drat and hex are to be dynamically linked,
# their dynamic libraries must be built after yorick
M_V2="TGT=dll" post$(DISTRIB_TGT)
postpkg: $(PKG_EXE)
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) "COPT=$(COPT)" $(M_V2); ); done

# two colons means these rules appended to Makepkg rule
clean::
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) TGT=exe clean; ); done
distclean::
	@for d in $(DIST_DIRS); do ( cd $$d; $(MAKE) TGT=exe distclean; ); done

# ------------------------------------- targets and rules for yor base package
# ydata.h: binio.h hash.h
# binio.h: hash.h
# yio.h: hash.h pstdio.h
# defmem.h: pstdlib.h
# bcast.h: ydata.h   binio.h hash.h
HSHAPI=hash.h ../play/plugin.h
HSH=hash.h
HGIST=../gist/gist.h ../gist/hlevel.h
PSLIB=../play/pstdlib.h $(PLAPI)
PSLIO=../play/pstdlib.h ../play/pstdio.h $(PLAPI)
PSPLAY=../play/pstdlib.h ../play/play.h $(PLAPI)
PLAYALL=../play/play.h ../play/pstdlib.h ../play/pstdio.h $(PLAPI)

array.o: ydata.h   binio.h $(HSHAPI)
ascio.o: ydata.h yio.h defmem.h $(PLAYALL)   binio.h $(HSH)
autold.o: ydata.h yio.h defmem.h $(PSLIO)   binio.h $(HSH)
bcast.o: bcast.h   ydata.h binio.h $(HSHAPI)
binio.o: ydata.h yio.h defmem.h $(PSLIO)   binio.h $(HSH)
binobj.o: bcast.h defmem.h $(PSLIB)   ydata.h binio.h $(HSH)
binpdb.o: ydata.h yio.h $(PSLIO)   binio.h $(HSH)
binstd.o: binio.h $(PSLIB)   $(HSH)
cache.o: binio.h $(PSLIO)   $(HSH)
clog.o: ydata.h yio.h $(PSLIO)   binio.h $(HSH)
convrt.o: binio.h $(PSLIB)   $(HSH)
debug.o: ydata.h yio.h $(PLAYALL)   binio.h $(HSH)
defmem.o: defmem.h   $(PSLIB)
fnctn.o: ydata.h   binio.h $(HSHAPI)
fortrn.o: fortrn.c yasync.h $(PSLIB)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(FORTRAN_LINKAGE) -o $@ -c fortrn.c
graph.o: graph.c ydata.h yio.h   binio.h $(HSH) $(PLAYALL) $(HGIST)
graph0.o: ydata.h   binio.h $(HSHAPI)
yhash.o: $(HSH) defmem.h $(PSLIB)
list.o: ydata.h defmem.h   binio.h $(HSHAPI)
nonc.o: nonc.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(NO_HYPOT) -o $@ -c nonc.c
ops.o: bcast.h $(PSLIB)   ydata.h binio.h $(HSH)
ops0.o: ydata.h   binio.h $(HSHAPI)
ops1.o: ydata.h   binio.h $(HSHAPI)
ops2.o: ydata.h   binio.h $(HSH) $(PSLIB)
ops3.o: bcast.h $(PSLIB)   ydata.h binio.h $(HSH)
opsv.o: ydata.h $(PSLIB) prmtyp.h   binio.h $(HSH)
parse.o: parse.h ydata.h $(PSLIB)   binio.h $(HSH)
pathfun.o: yio.h $(PSLIO)   $(HSH)
range.o: ydata.h $(PSLIB)   binio.h $(HSH)
std0.o: std0.c bcast.h yio.h defmem.h $(PLAYALL)   ydata.h binio.h $(HSH)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(D_Y_VERSION) -o $@ -c std0.c
std1.o: ydata.h $(PSPLAY)   binio.h $(HSH)
std2.o: ydata.h yio.h $(PLAYALL)   binio.h $(HSH)
style.o: style.c ydata.h $(PSLIB) $(HGIST) ../gist/draw.h   binio.h $(HSH)
task.o: ydata.h yio.h $(PLAYALL)   binio.h $(HSH)
ydata.o: bcast.h defmem.h $(PSLIB)   ydata.h binio.h $(HSH)
yinput.o: yio.h parse.h $(HSH) $(PLAYALL)
yio.o: yio.h defmem.h ydata.h $(PLAYALL)   binio.h $(HSH)
yorick.o: yorick.c parse.h $(PSPLAY)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(D_NO_STRTOUL) -o $@ -c yorick.c
yrdwr.o: bcast.h $(PSLIB)   ydata.h binio.h $(HSH)
YREH=../regexp/yfnmatch.h ../regexp/yregexp.h
ystr.o: ystr.c $(YREH) $(PSLIB) ydata.h binio.h $(HSH)
	$(CC) $(CPPFLAGS) $(CFLAGS) -I../regexp -o $@ -c ystr.c

# codger code generator computes ywrap.c and yinit.c source files
CDG_FLAGS=$(CFLAGS)
codger: codger.c
	$(CC) $(CPPFLAGS) $(CDG_FLAGS) $(FORTRAN_LINKAGE) -o codger codger.c

# numfmt computes binary number formats, results in prmtyp.h
prmtyp.h: ../play/any/numfmt ../play/any/numfmt.c
	../play/any/numfmt prmtyp.h
../play/any/numfmt:
	@cd ../play; $(MAKE) numfmt

# always compile main.c with -g so new packages can be debugged
main.o: main.c $(PLAYONLY)
	$(CC) $(CPPFLAGS) -g -I../play -o $@ -c main.c
main.c: ../play/$(Y_MAIN_C)
	cp ../play/$(Y_MAIN_C) main.c

config:
	./yconfig.sh

=== play/any/Makefile ===
SHELL=/bin/sh
MAKE=make
include ../../Make.cfg

COPT=$(COPT_DEFAULT)
CFLAGS=$(COPT) $(Y_CFLAGS) -I. -I.. $(PLAY_INCS) $(HACK_FLAGS)
CCLOAD=$(CC) $(COPT) $(Y_LDFLAGS)

OBJS=hash.o hash0.o hashctx.o hashid.o mm.o mminit.o \
  alarms.o pmemcpy.o pstrcpy.o pstrncat.o p595.o \
  bitrev.o bitlrot.o bitmrot.o

all: libplay

libplay: $(OBJS)
	$(AR) rc ../libplay.a $(OBJS)
	$(RANLIB) ../libplay.a
	touch $@

EXE_FILES=numfmt test2d hashtest
clean::
	rm -f *~ '#'* *.o *.a main.c core a.out $(EXE_FILES) libplay

distclean:: clean
	rm -f .gdb*



numfmt: numfmt.c
	$(CC) -g -o $@ numfmt.c

test2d: main.o test2d.o ../libplay.a
	$(CCLOAD) -o $@ main.o test2d.o -L.. -lplay $(X11LIB)

test: test2d

hashtest: hashtest.o ../libplay.a
	$(CCLOAD) -o $@ hashtest.o -L.. -lplay

PLUGEXT=../plugin.h

hash.o: $(PLAY_CFG)/config.h ../phash.h ../pstdlib.h $(PLUGEXT)
hash0.o: $(PLAY_CFG)/config.h ../phash.h $(PLUGEXT)
hashctx.o: $(PLAY_CFG)/config.h ../phash.h $(PLUGEXT)
hashid.o: $(PLAY_CFG)/config.h ../phash.h ../pstdlib.h $(PLUGEXT)

mm.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)
mminit.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)
pfrall.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)

alarms.o: $(PLAY_CFG)/config.h ../play.h ../pstdlib.h $(PLUGEXT)

pmemcpy.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)
pstrcpy.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)
pstrncat.o: $(PLAY_CFG)/config.h ../pstdlib.h $(PLUGEXT)

bitrev.o: $(PLAY_CFG)/config.h ../play.h $(PLUGEXT)
bitlrot.o: $(PLAY_CFG)/config.h ../play.h $(PLUGEXT)
bitmrot.o: $(PLAY_CFG)/config.h ../play.h $(PLUGEXT)
p595.o: ../play.h $(PLUGEXT)

test2d.o: ../play.h ../pstdlib.h ../pstdio.h $(PLUGEXT)
hashtest.o: ../phash.h ../pstdlib.h ../pstdio.h $(PLUGEXT)

main.o: main.c ../play.h $(PLUGEXT)
main.c: ../$(Y_MAIN_C)
	cp ../$(Y_MAIN_C) main.c

=== debian/changelog ===
yorick (1.6.02-1) unstable; urgency=low

  * upgrade to 1.6.02, see NEWS for changes

 -- David H. Munro <munro@icf.llnl.gov>  Sat, 12 Mar 2005 08:06:00 -0800

yorick (1.5.12-1) unstable; urgency=low

  * upgrade to 1.5.12, see NEWS for changes

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 21 Nov 2002 16:38:57 -0800

yorick (1.5.10-1) unstable; urgency=low

  * added -geometry switch to gist (Closes: #150115)
  * fixed gist font orientation (Closes: #150110)
  * reworded gist "partly illegible" warning (Closes: #150093)
  *   (the warning is not bogus, a file with cell arrays really
  *    would be partly illegible)
  * numerous other more serious bug fixes, see NEWS

 -- David H. Munro <munro@icf.llnl.gov>  Mon,  1 Jul 2002 15:12:04 -0800

yorick (1.5.08-1) unstable; urgency=low

  * 1.5.08 replaces infant mortality 1.5.07, see NEWS

 -- David H. Munro <munro@icf.llnl.gov>  Mon,  4 Feb 2002 08:47:40 -0800

yorick (1.5.07-1) unstable; urgency=low

  * renumber version to accomodate binary file change in upstream source
  * numerous bug fixes, see NEWS file

 -- David H. Munro <munro@icf.llnl.gov>  Mon, 28 Jan 2002 09:15:46 -0800

yorick (1.5-06) unstable; urgency=low

  * private release, never uploaded

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 25 Jan 2002 15:12:26 -0800

yorick (1.5-05) unstable; urgency=low

  * private release, never uploaded

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 25 Jan 2002 15:11:44 -0800

yorick (1.5-04) unstable; urgency=low

  * repair debian problems (Closes: #116588)

 -- David H. Munro <munro@icf.llnl.gov>  Mon, 22 Oct 2001 15:11:07 -0700

yorick (1.5-03) unstable; urgency=low

  * fixes many bugs in 1.5-02, see NEWS file

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 19 Oct 2001 15:11:07 -0700

yorick (1.5-02) frozen unstable; urgency=low

  * repairs debian/control (Closes: #105154)

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 19 Jul 2001 15:11:07 -0700

yorick (1.5-01) unstable; urgency=low

  * version 1.5.01 upstream release

 -- David H. Munro <munro@icf.llnl.gov>  Sat,  5 May 2001 12:45:38 -0700

yorick (1.4-15) unstable; urgency=low

  * resync 1.4-14.2 with upstream sources

 -- David H. Munro <munro@icf.llnl.gov>  Wed,  2 May 2001 14:27:45 -0700

yorick (1.4-14.2) unstable; urgency=low

  * NMU
  * Package is orphaned: maintainer set to the Debian QA Group,
  which acknowledges the previous NMU. (Closes: #91102, #91103, #91726,
  #91727, #91728)
  * Maintainer stated in the entry for yorick 1.4-13 that he had
  dealt with bugs 30857, 37405, 37587 and 39814, therefore I'm assuming
  he forgot to close them. (Closes: #30857, #37405, #37587, #39814)

 -- Carlos Laviola <claviola@ajato.com.br>  Sat, 21 Apr 2001 00:41:26 -0300

yorick (1.4-14.1) unstable; urgency=low

  * NMU
  * Yorick/doc/yorick.tex: Typo is fixed (Closes: #75177)
  * debian/rules: replaced every reference of /usr/{doc,man} with the proper
  		  paths, which are /usr/share/{doc,man} now.
  (Closes: #91102, #91103, #91726, #91727, #91728)
  * Upped Standards-Version to 3.5.2.

 -- Carlos Laviola <claviola@ajato.com.br>  Mon, 16 Apr 2001 21:41:45 -0300

yorick (1.4-14) frozen unstable; urgency=low

  * fix unsigned char parsing problems, other minor fixes

 -- David H. Munro <munro@icf.llnl.gov>  Mon, 17 Apr 2000 14:00:10 -0700

yorick (1.4-13) unstable; urgency=low

  * deal with bugs 30857 37405 37587 39814

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 30 Jul 1999 11:06:19 -0700

yorick (1.4-12) stable unstable; urgency=low

  * attempt to cope with slink and potato problems

 -- David H. Munro <munro@icf.llnl.gov>  Wed, 28 Apr 1999 10:30:17 -0700

yorick (1.4-11) frozen unstable; urgency=low

  * fixed bogus xdevel virtual package dependency

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 17 Dec 1998 09:48:48 -0800

yorick (1.4-10) frozen unstable; urgency=low

  * many bug fixes, see NEWS file

 -- David H. Munro <munro@icf.llnl.gov>  Mon,  7 Dec 1998 10:39:08 -0800

yorick (1.4-9) unstable; urgency=low

  * fixes bugs with rotated text and other graphics

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 10 Apr 1998 08:21:56 -0700

yorick (1.4-8) unstable; urgency=low

  * added copyright for yorick-dev, upstream bug fixes

 -- David H. Munro <munro@icf.llnl.gov>  Tue, 17 Mar 1998 12:21:04 -0800

yorick (1.4-7) unstable; urgency=low

  * fix double-align problem for x2 speedup of fft, matrix ops

 -- David H. Munro <munro@icf.llnl.gov>  Wed,  4 Feb 1998 17:19:27 -0800

yorick (1.4-6) unstable; urgency=low

  * rebuilt with libc6 and xlib6g for hamm

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 15 Jan 1998 18:20:14 -0800

yorick (1.4-5) unstable; urgency=low

  * upstream bug fixes thru 7/Nov/97 patch

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 7 Nov 1997 17:12:23 -0800

yorick (1.4-4) unstable; urgency=low

  * many small bug fixes and improvements

 -- David H. Munro <munro@icf.llnl.gov>  Tue, 7 Oct 1997 10:48:08 -0700

yorick (1.4-3) unstable; urgency=low

  * Fixed package description to conform with debian-policy.

 -- David H. Munro <munro@icf.llnl.gov>  Tue, 29 Apr 1997 09:23:08 -0700

yorick (1.4-2) unstable; urgency=low

  * fixed Gist/ps.ps, Yorick/ascio.c, yorick-dev and g77 dependencies

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 10 Apr 1997 11:49:39 -0700

yorick (1.4-1) unstable; urgency=low

  * New 1.4 version

 -- David H. Munro <munro@icf.llnl.gov>  Tue, 18 Mar 1997 17:56:14 -0800

yorick (1.3-3) unstable; urgency=low

  * install through patch-4 on ftp-icf.llnl.gov:/pub/Yorick

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 17 Jan 1997 14:11:51 -0800

yorick (1.3-2) unstable; urgency=low

  * Upgraded to debstd technology, included yorick-1.3-patch-1.

 -- David H. Munro <munro@icf.llnl.gov>  Fri, 3 Jan 1997 15:14:46 -0800

yorick (1.3-1) unstable; urgency=low

  * Initial Release.

 -- David H. Munro <munro@icf.llnl.gov>  Thu, 2 Jan 1997 12:38:08 -0800

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: yorick
Section: math
Priority: optional
Maintainer: David H. Munro <munro1@llnl.gov>
Build-Depends: xlibs-dev, texinfo, debmake
Standards-Version: 3.5.2

Package: yorick
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: yorick-dev, yorick-gist
Replaces: yorick-dev (<=1.4-15), yorick-gist (<=1.4-15)
Suggests: gs, xfig, yorick-doc
Description: interpreted language and scientific graphics
 Yorick is an interpreted programming language for:
  * scientific simulations or calculations
  * postprocessing or steering large simulation codes
  * interactive scientific graphics
  * reading, writing, and translating large files of numbers
 .
 The language features a compact syntax for many common array
 operations, so it processes large arrays of numbers very quickly and
 efficiently.  Superficially, yorick code resembles C code, but yorick
 variables are never explicitly declared and have a dynamic scoping
 similar to many Lisp dialects.  The yorick language is designed to be
 typed interactively at a keyboard, as well as stored in files for
 later use.
 .
 This package includes an emacs-based development environment, which
 you can launch by typing M-x yorick in emacs.
 .
 ftp://ftp-icf.llnl.gov/pub/Yorick/doc/index.html

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# Modified to be a prototype for debmake by Christoph Lameter <clameter@debian.org>

package=yorick
SHELL=/bin/bash

build:
	$(checkdir)
# expect the HOSTTYPE environment variable to be set and
# passed along by make, e.g.-  HOSTTYPE=i386
	make prefix=/usr ysite
	make
	make docs
	cd doc; make yorick.info
	strip gist/gist
	strip yorick/yorick
	touch build

clean:
	$(checkdir)
	-rm -f build
	-make distclean
	-rm -f Yorick/doc/yorick.info*
	-rm -f Yorick/doc/*.doc
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core

binary-indep:	checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.
# Actually, there are architecture independent files, but Yorick's install
# target installs them together with the architecture dependent files
# in /usr/share/yorick.

binary-arch:	checkroot build
	$(checkdir)
	-rm -rf debian/tmp
	install -d debian/tmp/usr/{bin,lib}
	make INSTALL_ROOT=debian/tmp Y_BINDIR=debian/tmp/usr/bin install
	install -d debian/tmp/usr/share/man/man1
	cp doc/yorick.1 doc/gist.1 debian/tmp/usr/share/man/man1
	install -d debian/tmp/usr/share/{info,doc}
	cp doc/yorick.info* debian/tmp/usr/share/info
	install -d debian/tmp/usr/share/yorick/1.6/contrib
	cp emacs/yorick.el debian/tmp/usr/share/yorick/1.6
	sed emacs/yorick-auto.el >debian/tmp/usr/share/yorick/1.6/yorick-auto.el -e s%'"'yorick%'"'/usr/share/yorick/1.6/yorick%g
	debstd
	dpkg-gencontrol -isp -p$(package)
	chown -R root.root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

define checkdir
	test -f debian/rules
endef

# Below here is fairly generic really

binary:		binary-indep binary-arch

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
